#include <stdlib.h>
#include "ostdb.h"
#include "config.h"
#include "cdbslib.h"
#include "loadfile.h"
#include "dbquery.h"
#include "getref.h"
#include "readroot.h"

#define  EXPAND		NO

/* EXPAND_ASSOC -- Expand an list of associations into a list of files
 *
 * i: qry	database query context
 */

textbuf *expand_assoc (context *qry) {

    rooter	*rp;
    textbuf	*list;
    int		found;
    char	*root, *assoc;
    char	dataset[SZ_DBFIELD+1];

    static char *assoc_fmt = "select asm_member_name from assoc_member "
	"where asm_data_set_name = ^";

    /* Allocate text buffer to hold results */

    list = (textbuf *) malloc (sizeof (textbuf));
    init_text (list, 10, 100);

    /* Read each association name from user input */

    root = get_option ("root");
    rp = start_read_root (root);

    while ((assoc = read_root (rp)) != NULL) {
	if (EXPAND == NO) { 
	    add_text (list, assoc);

	} else {
	    /* Initialize database query */

	    ostdb_query_setup (qry->connection, "expand_assoc", 1, STDB_SQL,
			       qry->server, qry->dads_db, db_error);

	    stdb_bind_string (qry->connection, "asm_member_name", dataset, 
			      SZ_DBFIELD);

	    /* Query database for members of association */

	    build_qry (qry->connection, assoc_fmt, strucase(enquote(assoc)));

	    /* Copy association member names to text buffer */

	    found = NO;
	    while (ostdb_get_exec (qry->connection) == STDB_CONTINUE) {
		found = YES;
		clean_data (dataset);
		add_text (list, dataset);
	    }

	    /* Or copy original name if no members found */

	    if (found == NO)
		add_text (list, assoc);

	    stdb_close_query (qry->connection);
	}
    }

    /* Clean up and return address of buffer */

    end_read_root (rp);

    return list;
}

/* FREE_ASSOC -- Free list generated by expand_assoc
 *
 * i: list	list of association member names
 */

void free_assoc (textbuf *list) {

    free_text (list);
    free (list);
}
